// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDColorControl.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDColorControl 
//               Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDColorControl.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDColorControl*)
{
    new TDDColorControl(NULL);
}
// --------------------------------------------------------------------------
namespace Tddcolorcontrol
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDColorControl)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDColorControl::TDDColorControl()
// Description: The default constructor for the TDDColorControl object.
// --------------------------------------------------------------------------
__fastcall TDDColorControl::TDDColorControl(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDColorControl::~TDDColorControl()
// Description: The destructor for the TDDColorControl object.
// --------------------------------------------------------------------------
__fastcall TDDColorControl::~TDDColorControl()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    Brightness
// Description: The Brightness property defines the luminance intensity, in 
//              IRE units, multiplied by 100. 
//              The possible range is from 0 to 10,000 with a default of 750. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetBrightness()
{
return fDDCOLORCONTROL.lBrightness;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetBrightness( long pBrightness )
{
fDDCOLORCONTROL.lBrightness = pBrightness;
}
// --------------------------------------------------------------------------
// Property:    ColorEnable
// Description: The ColorEnable property defines whether color is utilized or 
//              not. 
//              Color is used if this property is 1. Color is not used if 
//              this property is 0. The default value is 1. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetColorEnable()
{
return fDDCOLORCONTROL.lColorEnable;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetColorEnable( long pColorEnable )
{
fDDCOLORCONTROL.lColorEnable = pColorEnable;
}
// --------------------------------------------------------------------------
// Property:    Contrast
// Description: The Contrast property defines the relative difference between 
//              higher and lower luminance values, in IRE units, multiplied 
//              by 100. 
//              The possible range is from 0 to 20,000 with a default value 
//              of 10,000. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetContrast()
{
return fDDCOLORCONTROL.lContrast;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetContrast( long pContrast )
{
fDDCOLORCONTROL.lContrast = pContrast;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDColorControl method or 
//              fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDColorControl::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating which of this 
//              components properties contain valid data. 
//              When returned by TDx_DrawColorControl::GetColorControls(), 
//              these flags indicate which color controls are supported. 
//              The described effect applies when the flag is set. 
// Flags:       DDCOLOR_BRIGHTNESS -
//                TDDColorControl::Brightness contains valid data or 
//                brightness control is supported. 
//              DDCOLOR_COLORENABLE -
//                TDDColorControl::ColorEnable contains valid data or color 
//                usage can be enabled or disabled. 
//              DDCOLOR_CONTRAST -
//                TDDColorControl::Contrast contains valid data or contrast 
//                control is supported. 
//              DDCOLOR_GAMMA -
//                TDDColorControl::Gamma contains valid data or gamma control 
//                is supported. 
//              DDCOLOR_HUE -
//                TDDColorControl::Hue contains valid data or hue control is 
//                supported. 
//              DDCOLOR_SATURATION -
//                TDDColorControl::Saturation contains valid data or 
//                saturation control is supported. 
//              DDCOLOR_SHARPNESS -
//                TDDColorControl::Sharpness contains valid data or sharpness 
//                control is supported. 
// --------------------------------------------------------------------------
dword __fastcall TDDColorControl::FGetFlags()
{
return fDDCOLORCONTROL.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetFlags( dword pFlags )
{
fDDCOLORCONTROL.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Gamma
// Description: The Gamma property defines the amount, in gamma units, of 
//              gamma correction applied to the luminance values. 
//              The possible range is from 1 to 500, with a default of 1. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetGamma()
{
return fDDCOLORCONTROL.lGamma;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetGamma( long pGamma )
{
fDDCOLORCONTROL.lGamma = pGamma;
}
// --------------------------------------------------------------------------
// Property:    Hue
// Description: The Hue property defines the phase relationship, in degrees, 
//              of the chrominance components. 
//              The possible range is from -180 to 180, with a default of 0. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetHue()
{
return fDDCOLORCONTROL.lHue;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetHue( long pHue )
{
fDDCOLORCONTROL.lHue = pHue;
}
// --------------------------------------------------------------------------
// Property:    Saturation
// Description: The Saturation property defines the color intensity, in IRE 
//              units, multiplied by 100. 
//              The possible range is 0 to 20,000, with a default value of 
//              10,000. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetSaturation()
{
return fDDCOLORCONTROL.lSaturation;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetSaturation( long pSaturation )
{
fDDCOLORCONTROL.lSaturation = pSaturation;
}
// --------------------------------------------------------------------------
// Property:    Sharpness
// Description: The Sharpness property defines the sharpness, in arbitrary 
//              units, of an image. 
//              The possible range is 0 to 10, with a default value of 5. 
// --------------------------------------------------------------------------
long __fastcall TDDColorControl::FGetSharpness()
{
return fDDCOLORCONTROL.lSharpness;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetSharpness( long pSharpness )
{
fDDCOLORCONTROL.lSharpness = pSharpness;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDColorControl::FGetSize()
{
return fDDCOLORCONTROL.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetSize( dword pSize )
{
fDDCOLORCONTROL.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDColorControl's internal DDCOLORCONTROL structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::Clear()
{
fDDCOLORCONTROL.lBrightness = 0;
fDDCOLORCONTROL.lColorEnable = 0;
fDDCOLORCONTROL.lContrast = 0;
fErrorValue = DD_OK;
fDDCOLORCONTROL.dwFlags = 0;
fDDCOLORCONTROL.lGamma = 0;
fDDCOLORCONTROL.lHue = 0;
fDDCOLORCONTROL.lSaturation = 0;
fDDCOLORCONTROL.lSharpness = 0;
fDDCOLORCONTROL.dwSize = sizeof(DDCOLORCONTROL);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDCOLORCONTROL* __fastcall TDDColorControl::FGetInternal_DDCOLORCONTROL_Ptr()
{
return &fDDCOLORCONTROL;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetInternal_DDCOLORCONTROL( DDCOLORCONTROL* pDDCOLORCONTROL )
{
if (pDDCOLORCONTROL==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDColorControl::FSetInternal_DDCOLORCONTROL()", "TDX_ERROR", "The supplied DDCOLORCONTROL* was NULL" );
    return;
    }

CopyMemory( &fDDCOLORCONTROL, pDDCOLORCONTROL, sizeof(DDCOLORCONTROL) );
Internal_DDCOLORCONTROL_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::Internal_DDCOLORCONTROL_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDColorControl_Flags_Set<> of the 
//              flags in the current fDDCOLORCONTROL.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDColorControl_Flags_Set __fastcall TDDColorControl::FGetFlags_()
{
TDDColorControl_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_BRIGHTNESS) TempFlags_ = TempFlags_ << ddcolor_brightness;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_COLORENABLE) TempFlags_ = TempFlags_ << ddcolor_colorenable;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_CONTRAST) TempFlags_ = TempFlags_ << ddcolor_contrast;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_GAMMA) TempFlags_ = TempFlags_ << ddcolor_gamma;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_HUE) TempFlags_ = TempFlags_ << ddcolor_hue;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_SATURATION) TempFlags_ = TempFlags_ << ddcolor_saturation;
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_SHARPNESS) TempFlags_ = TempFlags_ << ddcolor_sharpness;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDDColorControl::FSetFlags_( TDDColorControl_Flags_Set pFlags_ )
{
fDDCOLORCONTROL.dwFlags = 0;
if (pFlags_.Contains(ddcolor_brightness)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_BRIGHTNESS;
if (pFlags_.Contains(ddcolor_colorenable)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_COLORENABLE;
if (pFlags_.Contains(ddcolor_contrast)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_CONTRAST;
if (pFlags_.Contains(ddcolor_gamma)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_GAMMA;
if (pFlags_.Contains(ddcolor_hue)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_HUE;
if (pFlags_.Contains(ddcolor_saturation)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_SATURATION;
if (pFlags_.Contains(ddcolor_sharpness)) fDDCOLORCONTROL.dwFlags |= DDCOLOR_SHARPNESS;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDColorControl::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDColorControl::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_BRIGHTNESS) fFlags_Strings->Add("DDCOLOR_BRIGHTNESS");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_COLORENABLE) fFlags_Strings->Add("DDCOLOR_COLORENABLE");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_CONTRAST) fFlags_Strings->Add("DDCOLOR_CONTRAST");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_GAMMA) fFlags_Strings->Add("DDCOLOR_GAMMA");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_HUE) fFlags_Strings->Add("DDCOLOR_HUE");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_SATURATION) fFlags_Strings->Add("DDCOLOR_SATURATION");
if (fDDCOLORCONTROL.dwFlags & DDCOLOR_SHARPNESS) fFlags_Strings->Add("DDCOLOR_SHARPNESS");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
