// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDGammaRamp.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDGammaRamp Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDGammaRamp.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDGammaRamp*)
{
    new TDDGammaRamp(NULL);
}
// --------------------------------------------------------------------------
namespace Tddgammaramp
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDGammaRamp)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDGammaRamp::TDDGammaRamp()
// Description: The default constructor for the TDDGammaRamp object.
// --------------------------------------------------------------------------
__fastcall TDDGammaRamp::TDDGammaRamp(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDDGammaRamp::~TDDGammaRamp()
// Description: The destructor for the TDDGammaRamp object.
// --------------------------------------------------------------------------
__fastcall TDDGammaRamp::~TDDGammaRamp()
{
}
// --------------------------------------------------------------------------
// Property:    Blue
// Description: The Blue property references an array holding the gamma ramp 
//              for the blue color component. 
// --------------------------------------------------------------------------
word __fastcall TDDGammaRamp::FGetBlue( dword pIndex )
{
if (pIndex>=256)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDGammaRamp::FGetBlue()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (WORD) NULL;
    }
return fDDGAMMARAMP.blue[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetBlue( dword pIndex, word pBlue )
{
fDDGAMMARAMP.blue[pIndex] = pBlue;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDGammaRamp method or fget/fset. 
//              eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDGammaRamp::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Green
// Description: The Green property references an array holding the gamma ramp 
//              for the green color component. 
// --------------------------------------------------------------------------
word __fastcall TDDGammaRamp::FGetGreen( dword pIndex )
{
if (pIndex>=256)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDGammaRamp::FGetGreen()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (WORD) NULL;
    }
return fDDGAMMARAMP.green[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetGreen( dword pIndex, word pGreen )
{
fDDGAMMARAMP.green[pIndex] = pGreen;
}
// --------------------------------------------------------------------------
// Property:    Red
// Description: The Red property references an array holding the gamma ramp 
//              for the red color component. 
// --------------------------------------------------------------------------
word __fastcall TDDGammaRamp::FGetRed( dword pIndex )
{
if (pIndex>=256)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDGammaRamp::FGetRed()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (WORD) NULL;
    }
return fDDGAMMARAMP.red[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetRed( dword pIndex, word pRed )
{
fDDGAMMARAMP.red[pIndex] = pRed;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DDGAMMARAMP structure. 
// --------------------------------------------------------------------------
dword __fastcall TDDGammaRamp::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDGammaRamp's internal DDGAMMARAMP structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::Clear()
{
for (int Blue_index=0;Blue_index<256;Blue_index++) fDDGAMMARAMP.blue[Blue_index] = 0;
fErrorValue = DD_OK;
for (int Green_index=0;Green_index<256;Green_index++) fDDGAMMARAMP.green[Green_index] = 0;
for (int Red_index=0;Red_index<256;Red_index++) fDDGAMMARAMP.red[Red_index] = 0;
fSize = sizeof(DDGAMMARAMP);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDGAMMARAMP* __fastcall TDDGammaRamp::FGetInternal_DDGAMMARAMP_Ptr()
{
return &fDDGAMMARAMP;
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::FSetInternal_DDGAMMARAMP( DDGAMMARAMP* pDDGAMMARAMP )
{
if (pDDGAMMARAMP==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDGammaRamp::FSetInternal_DDGAMMARAMP()", "TDX_ERROR", "The supplied DDGAMMARAMP* was NULL" );
    return;
    }

CopyMemory( &fDDGAMMARAMP, pDDGAMMARAMP, sizeof(DDGAMMARAMP) );
Internal_DDGAMMARAMP_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDGammaRamp::Internal_DDGAMMARAMP_Update()
{
}

// --------------------------------------------------------------------------
