// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDOverlayFX.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDOverlayFX Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDOverlayFX.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDOverlayFX*)
{
    new TDDOverlayFX(NULL);
}
// --------------------------------------------------------------------------
namespace Tddoverlayfx
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDOverlayFX)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDOverlayFX::TDDOverlayFX()
// Description: The default constructor for the TDDOverlayFX object.
// --------------------------------------------------------------------------
__fastcall TDDOverlayFX::TDDOverlayFX(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFX_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDOverlayFX::~TDDOverlayFX()
// Description: The destructor for the TDDOverlayFX object.
// --------------------------------------------------------------------------
__fastcall TDDOverlayFX::~TDDOverlayFX()
{
if (fFX_Strings!=NULL) delete fFX_Strings;
}
// --------------------------------------------------------------------------
// Property:    AlphaDestConst
// Description: The AlphaDestConst property defines the constant used as the 
//              destination overlay alpha channel when 
//              DDOVER_ALPHADESTCONSTOVERRIDE is set in the Flags parameter 
//              of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaDestConst()
{
return fDDOVERLAYFX.dwAlphaDestConst;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaDestConst( dword pAlphaDestConst )
{
fDDOVERLAYFX.dwAlphaDestConst = pAlphaDestConst;
}
// --------------------------------------------------------------------------
// Property:    AlphaDestConstBitDepth
// Description: The AlphaDestConstBitDepth property defines the bit depth of 
//              TDDOverlayFX::AlphaDestConst. 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaDestConstBitDepth()
{
return fDDOVERLAYFX.dwAlphaDestConstBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaDestConstBitDepth( dword pAlphaDestConstBitDepth )
{
fDDOVERLAYFX.dwAlphaDestConstBitDepth = pAlphaDestConstBitDepth;
}
// --------------------------------------------------------------------------
// Property:    AlphaEdgeBlend
// Description: The AlphaEdgeBlend property defines the constant to be used 
//              for alpha edge blending when DDOVER_ALPHAEDGEBLEND is set in 
//              the Flags parameter of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaEdgeBlend()
{
return fDDOVERLAYFX.dwAlphaEdgeBlend;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaEdgeBlend( dword pAlphaEdgeBlend )
{
fDDOVERLAYFX.dwAlphaEdgeBlend = pAlphaEdgeBlend;
}
// --------------------------------------------------------------------------
// Property:    AlphaEdgeBlendBitDepth
// Description: The AlphaEdgeBlendBitDepth property defines the bit depth of 
//              TDDOverlayFX::AlphaEdgeBlend. 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaEdgeBlendBitDepth()
{
return fDDOVERLAYFX.dwAlphaEdgeBlendBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaEdgeBlendBitDepth( dword pAlphaEdgeBlendBitDepth )
{
fDDOVERLAYFX.dwAlphaEdgeBlendBitDepth = pAlphaEdgeBlendBitDepth;
}
// --------------------------------------------------------------------------
// Property:    AlphaSrcConst
// Description: The AlphaSrcConst property defines the constant used as the 
//              source overlay alpha channel when 
//              DDOVER_ALPHASRCCONSTOVERRIDE is set in the Flags parameter of 
//              TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaSrcConst()
{
return fDDOVERLAYFX.dwAlphaSrcConst;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaSrcConst( dword pAlphaSrcConst )
{
fDDOVERLAYFX.dwAlphaSrcConst = pAlphaSrcConst;
}
// --------------------------------------------------------------------------
// Property:    AlphaSrcConstBitDepth
// Description: The AlphaSrcConstBitDepth property defines the bit depth of 
//              TDDOverlayFX::AlphaSrcConst. 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetAlphaSrcConstBitDepth()
{
return fDDOVERLAYFX.dwAlphaSrcConstBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetAlphaSrcConstBitDepth( dword pAlphaSrcConstBitDepth )
{
fDDOVERLAYFX.dwAlphaSrcConstBitDepth = pAlphaSrcConstBitDepth;
}
// --------------------------------------------------------------------------
// Property:    DestColorkey
// Description: The DestColorkey property references the destination color 
//              key to be used when DDOVER_KEYDESTOVERRIDE flag is set in the 
//              Flags parameter of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDOverlayFX::FGetDestColorkey()
{
if (ComponentState.Contains(csDesigning) &&
    (fDestColorkey!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fDestColorkey)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fDestColorkey=NULL;
    }
return fDestColorkey;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetDestColorkey( TDDColorKey* pDestColorkey )
{
fDestColorkey = pDestColorkey;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDOverlayFX method or fget/fset. 
//              eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDOverlayFX::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FX
// Description: The FX property defines flags indicating what overlay 
//              stretching or mirroring effects are to be used. 
//              The described effect applies when the flag is set. 
// Flags:       DDOVERFX_ARITHSTRETCHY -
//                Stretching of the overlay along the Y axis will utilize 
//                arithmetic stretching techniques. 
//              DDOVERFX_MIRRORLEFTRIGHT -
//                The overlay is to be mirrored around the Y axis. 
//              DDOVERFX_MIRRORUPDOWN -
//                The overlay is to be mirrored around the X axis. 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetFX()
{
return fDDOVERLAYFX.dwDDFX;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetFX( dword pFX )
{
fDDOVERLAYFX.dwDDFX = pFX;
}
// --------------------------------------------------------------------------
// Property:    SAlphaDest
// Description: The SAlphaDest property references the surface used as the 
//              destination overlay alpha channel when 
//              DDOVER_ALPHADESTSURFACEOVERRIDE is set in the Flags parameter 
//              of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
TDx_DrawSurface* __fastcall TDDOverlayFX::FGetSAlphaDest()
{
if (ComponentState.Contains(csDesigning) &&
    (fSAlphaDest!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSAlphaDest)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSAlphaDest=NULL;
    }
return fSAlphaDest;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetSAlphaDest( TDx_DrawSurface* pSAlphaDest )
{
if (fSAlphaDest!=NULL)
    {
    fDDOVERLAYFX.lpDDSAlphaDest = (LPDIRECTDRAWSURFACE) fSAlphaDest->Internal_LPDIRECTDRAWSURFACE7;
    }
}
// --------------------------------------------------------------------------
// Property:    SAlphaSrc
// Description: The SAlphaSrc property references the surface used as the 
//              source overlay alpha channel when 
//              DDOVER_ALPHASRCSURFACEOVERRIDE flag is set in the Flags 
//              parameter of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
TDx_DrawSurface* __fastcall TDDOverlayFX::FGetSAlphaSrc()
{
if (ComponentState.Contains(csDesigning) &&
    (fSAlphaSrc!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSAlphaSrc)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSAlphaSrc=NULL;
    }
return fSAlphaSrc;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetSAlphaSrc( TDx_DrawSurface* pSAlphaSrc )
{
if (fSAlphaSrc!=NULL)
    {
    fDDOVERLAYFX.lpDDSAlphaSrc = (LPDIRECTDRAWSURFACE) fSAlphaSrc->Internal_LPDIRECTDRAWSURFACE7;
    }
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDOverlayFX::FGetSize()
{
return fDDOVERLAYFX.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetSize( dword pSize )
{
fDDOVERLAYFX.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SrcColorkey
// Description: The SrcColorkey property references the source color key to 
//              be used when DDOVER_KEYSRCOVERRIDE is set in the Flags 
//              parameter of TDx_DrawSurface::UpdateOverlay(). 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDOverlayFX::FGetSrcColorkey()
{
if (ComponentState.Contains(csDesigning) &&
    (fSrcColorkey!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSrcColorkey)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSrcColorkey=NULL;
    }
return fSrcColorkey;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetSrcColorkey( TDDColorKey* pSrcColorkey )
{
fSrcColorkey = pSrcColorkey;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDOverlayFX's internal DDOVERLAYFX structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::Clear()
{
fDDOVERLAYFX.dwAlphaDestConst = 0;
fDDOVERLAYFX.dwAlphaDestConstBitDepth = 0;
fDDOVERLAYFX.dwAlphaEdgeBlend = 0;
fDDOVERLAYFX.dwAlphaEdgeBlendBitDepth = 0;
fDDOVERLAYFX.dwAlphaSrcConst = 0;
fDDOVERLAYFX.dwAlphaSrcConstBitDepth = 0;
fDestColorkey = NULL;
fErrorValue = DD_OK;
fDDOVERLAYFX.dwDDFX = 0;
fSAlphaDest = NULL;
fSAlphaSrc = NULL;
fDDOVERLAYFX.dwSize = sizeof(DDOVERLAYFX);
fSrcColorkey = NULL;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDOVERLAYFX* __fastcall TDDOverlayFX::FGetInternal_DDOVERLAYFX_Ptr()
{
if (fDestColorkey!=NULL) CopyMemory( &fDDOVERLAYFX.dckDestColorkey, fDestColorkey->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
if (fSrcColorkey!=NULL) CopyMemory( &fDDOVERLAYFX.dckSrcColorkey, fSrcColorkey->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
return &fDDOVERLAYFX;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetInternal_DDOVERLAYFX( DDOVERLAYFX* pDDOVERLAYFX )
{
if (pDDOVERLAYFX==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDOverlayFX::FSetInternal_DDOVERLAYFX()", "TDX_ERROR", "The supplied DDOVERLAYFX* was NULL" );
    return;
    }

CopyMemory( &fDDOVERLAYFX, pDDOVERLAYFX, sizeof(DDOVERLAYFX) );
Internal_DDOVERLAYFX_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::Internal_DDOVERLAYFX_Update()
{
if (fDestColorkey!=NULL) CopyMemory( fDestColorkey->Internal_DDCOLORKEY_Ptr, &fDDOVERLAYFX.dckDestColorkey, sizeof(DDCOLORKEY) );
if (fSrcColorkey!=NULL) CopyMemory( fSrcColorkey->Internal_DDCOLORKEY_Ptr, &fDDOVERLAYFX.dckSrcColorkey, sizeof(DDCOLORKEY) );
}

// --------------------------------------------------------------------------
// Method:      FGetFX_
// Description: This method returns a TDDOverlayFX_FX_Set<> of the flags in 
//              the current fDDOVERLAYFX.dwDDFX. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDOverlayFX_FX_Set __fastcall TDDOverlayFX::FGetFX_()
{
TDDOverlayFX_FX_Set TempFX_;
TempFX_.Clear();
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_ARITHSTRETCHY) TempFX_ = TempFX_ << ddoverfx_arithstretchy;
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_MIRRORLEFTRIGHT) TempFX_ = TempFX_ << ddoverfx_mirrorleftright;
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_MIRRORUPDOWN) TempFX_ = TempFX_ << ddoverfx_mirrorupdown;
return TempFX_;
}
// --------------------------------------------------------------------------
void __fastcall TDDOverlayFX::FSetFX_( TDDOverlayFX_FX_Set pFX_ )
{
fDDOVERLAYFX.dwDDFX = 0;
if (pFX_.Contains(ddoverfx_arithstretchy)) fDDOVERLAYFX.dwDDFX |= DDOVERFX_ARITHSTRETCHY;
if (pFX_.Contains(ddoverfx_mirrorleftright)) fDDOVERLAYFX.dwDDFX |= DDOVERFX_MIRRORLEFTRIGHT;
if (pFX_.Contains(ddoverfx_mirrorupdown)) fDDOVERLAYFX.dwDDFX |= DDOVERFX_MIRRORUPDOWN;
}
// --------------------------------------------------------------------------
// Method:      FGetFX_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'FX' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDOverlayFX::FGetFX_Strings()
{
// if the strings have not been allocated
if (fFX_Strings==NULL)
    {
    // attempt to allocate the strings
    fFX_Strings = new TStringList();
    // if the allocation failed
    if (fFX_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDOverlayFX::FGetFX_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various FX_Strings" );
        return NULL;
        }
    }
fFX_Strings->Clear();
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_ARITHSTRETCHY) fFX_Strings->Add("DDOVERFX_ARITHSTRETCHY");
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_MIRRORLEFTRIGHT) fFX_Strings->Add("DDOVERFX_MIRRORLEFTRIGHT");
if (fDDOVERLAYFX.dwDDFX & DDOVERFX_MIRRORUPDOWN) fFX_Strings->Add("DDOVERFX_MIRRORUPDOWN");
return fFX_Strings;
}
// --------------------------------------------------------------------------
