// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortBandwidth.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortBandwidth 
//               Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortBandwidth.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortBandwidth*)
{
    new TDDVideoPortBandwidth(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportbandwidth
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortBandwidth)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortBandwidth::TDDVideoPortBandwidth()
// Description: The default constructor for the TDDVideoPortBandwidth object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortBandwidth::TDDVideoPortBandwidth(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fCaps_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortBandwidth::~TDDVideoPortBandwidth()
// Description: The destructor for the TDDVideoPortBandwidth object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortBandwidth::~TDDVideoPortBandwidth()
{
if (fCaps_Strings!=NULL) delete fCaps_Strings;
}
// --------------------------------------------------------------------------
// Property:    Caps
// Description: The Caps property defines flags indicating how the other 
//              properties of this component are to be interpreted. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPBCAPS_DESTINATION -
//                The device capabilities are described in terms of the 
//                overlay's minimum stretch factor. 
//                This means bandwidth information provided for this device 
//                refers to the destination overlay size. 
//                The stretch factors detailed in the other properties of 
//                this component represent the minimum stretch factor that 
//                needs to be applied to successfully display an overlay of 
//                the size specified in the 
//                TDx_DrawVideoPort::GetBandwidthInfo() call. 
//              DDVPBCAPS_SOURCE -
//                The device capabilities are described in terms of the 
//                required source overlay size. 
//                This means bandwidth information provided for this device 
//                refers to the source overlay size. 
//                The stretch factors detailed in the other properties of 
//                this component represent how much the source overlay must 
//                be shrunk to successfully display an overlay of the size 
//                specified in the TDx_DrawVideoPort::GetBandwidthInfo() 
//                call. 
//                A value of 1000 indicates no modifications are required, a 
//                smaller value indicates the suggested source rectangle was 
//                too large. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetCaps()
{
return fDDVIDEOPORTBANDWIDTH.dwCaps;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetCaps( dword pCaps )
{
fDDVIDEOPORTBANDWIDTH.dwCaps = pCaps;
}
// --------------------------------------------------------------------------
// Property:    Colorkey
// Description: The Colorkey property defines a stretch factor indicating the 
//              size requirements for the video port to display an overlay 
//              with color keying, relative to the dimensions provided in the 
//              TDx_DrawVideoPort::GetBandwidthInfo call. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetColorkey()
{
return fDDVIDEOPORTBANDWIDTH.dwColorkey;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetColorkey( dword pColorkey )
{
fDDVIDEOPORTBANDWIDTH.dwColorkey = pColorkey;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortBandwidth method or 
//              fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortBandwidth::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Overlay
// Description: The Overlay property defines a stretch factor indicating the 
//              size requirements for the video port to display an overlay, 
//              relative to the dimensions provided in the 
//              TDx_DrawVideoPort::GetBandwidthInfo() call. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetOverlay()
{
return fDDVIDEOPORTBANDWIDTH.dwOverlay;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetOverlay( dword pOverlay )
{
fDDVIDEOPORTBANDWIDTH.dwOverlay = pOverlay;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetSize()
{
return fDDVIDEOPORTBANDWIDTH.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetSize( dword pSize )
{
fDDVIDEOPORTBANDWIDTH.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    YInterpAndColorkey
// Description: The YInterpAndColorkey property defines a stretch factor 
//              indicating the size requirements for the display of an 
//              overlay with Y axis interpolation and color keying, relative 
//              to the dimensions provided in the 
//              TDx_DrawVideoPort::GetBandwidthInfo() call. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetYInterpAndColorkey()
{
return fDDVIDEOPORTBANDWIDTH.dwYInterpAndColorkey;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetYInterpAndColorkey( dword pYInterpAndColorkey )
{
fDDVIDEOPORTBANDWIDTH.dwYInterpAndColorkey = pYInterpAndColorkey;
}
// --------------------------------------------------------------------------
// Property:    YInterpolate
// Description: The YInterpolate property defines a stretch factor indicating 
//              the size requirements for the display of an overlay with Y 
//              axis interpolation, relative to the dimensions provided in 
//              the TDx_DrawVideoPort::GetBandwidthInfo call. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortBandwidth::FGetYInterpolate()
{
return fDDVIDEOPORTBANDWIDTH.dwYInterpolate;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetYInterpolate( dword pYInterpolate )
{
fDDVIDEOPORTBANDWIDTH.dwYInterpolate = pYInterpolate;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortBandwidth's internal DDVIDEOPORTBANDWIDTH 
//              structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::Clear()
{
fDDVIDEOPORTBANDWIDTH.dwCaps = 0;
fDDVIDEOPORTBANDWIDTH.dwColorkey = 0;
fErrorValue = DD_OK;
fDDVIDEOPORTBANDWIDTH.dwOverlay = 0;
fDDVIDEOPORTBANDWIDTH.dwSize = sizeof(DDVIDEOPORTBANDWIDTH);
fDDVIDEOPORTBANDWIDTH.dwYInterpAndColorkey = 0;
fDDVIDEOPORTBANDWIDTH.dwYInterpolate = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDVIDEOPORTBANDWIDTH* __fastcall TDDVideoPortBandwidth::FGetInternal_DDVIDEOPORTBANDWIDTH_Ptr()
{
return &fDDVIDEOPORTBANDWIDTH;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetInternal_DDVIDEOPORTBANDWIDTH( DDVIDEOPORTBANDWIDTH* pDDVIDEOPORTBANDWIDTH )
{
if (pDDVIDEOPORTBANDWIDTH==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortBandwidth::FSetInternal_DDVIDEOPORTBANDWIDTH()", "TDX_ERROR", "The supplied DDVIDEOPORTBANDWIDTH* was NULL" );
    return;
    }

CopyMemory( &fDDVIDEOPORTBANDWIDTH, pDDVIDEOPORTBANDWIDTH, sizeof(DDVIDEOPORTBANDWIDTH) );
Internal_DDVIDEOPORTBANDWIDTH_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::Internal_DDVIDEOPORTBANDWIDTH_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetCaps_
// Description: This method returns a TDDVideoPortBandwidth_Caps_Set<> of the 
//              flags in the current fDDVIDEOPORTBANDWIDTH.dwCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortBandwidth_Caps_Set __fastcall TDDVideoPortBandwidth::FGetCaps_()
{
TDDVideoPortBandwidth_Caps_Set TempCaps_;
TempCaps_.Clear();
if (fDDVIDEOPORTBANDWIDTH.dwCaps & DDVPBCAPS_DESTINATION) TempCaps_ = TempCaps_ << ddvpbcaps_destination;
if (fDDVIDEOPORTBANDWIDTH.dwCaps & DDVPBCAPS_SOURCE) TempCaps_ = TempCaps_ << ddvpbcaps_source;
return TempCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortBandwidth::FSetCaps_( TDDVideoPortBandwidth_Caps_Set pCaps_ )
{
fDDVIDEOPORTBANDWIDTH.dwCaps = 0;
if (pCaps_.Contains(ddvpbcaps_destination)) fDDVIDEOPORTBANDWIDTH.dwCaps |= DDVPBCAPS_DESTINATION;
if (pCaps_.Contains(ddvpbcaps_source)) fDDVIDEOPORTBANDWIDTH.dwCaps |= DDVPBCAPS_SOURCE;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortBandwidth::FGetCaps_Strings()
{
// if the strings have not been allocated
if (fCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps_Strings = new TStringList();
    // if the allocation failed
    if (fCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortBandwidth::FGetCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps_Strings" );
        return NULL;
        }
    }
fCaps_Strings->Clear();
if (fDDVIDEOPORTBANDWIDTH.dwCaps & DDVPBCAPS_DESTINATION) fCaps_Strings->Add("DDVPBCAPS_DESTINATION");
if (fDDVIDEOPORTBANDWIDTH.dwCaps & DDVPBCAPS_SOURCE) fCaps_Strings->Add("DDVPBCAPS_SOURCE");
return fCaps_Strings;
}
// --------------------------------------------------------------------------
