// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortCaps.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortCaps 
//               Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortCaps.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortCaps*)
{
    new TDDVideoPortCaps(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportcaps
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortCaps)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortCaps::TDDVideoPortCaps()
// Description: The default constructor for the TDDVideoPortCaps object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortCaps::TDDVideoPortCaps(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fCaps_Strings=NULL;
fFX_Strings=NULL;
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortCaps::~TDDVideoPortCaps()
// Description: The destructor for the TDDVideoPortCaps object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortCaps::~TDDVideoPortCaps()
{
if (fCaps_Strings!=NULL) delete fCaps_Strings;
if (fFX_Strings!=NULL) delete fFX_Strings;
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    AlignVideoPortBoundary
// Description: The AlignVideoPortBoundary property defines where the video 
//              port may be placed within a surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetAlignVideoPortBoundary()
{
return fDDVIDEOPORTCAPS.dwAlignVideoPortBoundary;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetAlignVideoPortBoundary( dword pAlignVideoPortBoundary )
{
fDDVIDEOPORTCAPS.dwAlignVideoPortBoundary = pAlignVideoPortBoundary;
}
// --------------------------------------------------------------------------
// Property:    AlignVideoPortCropBoundary
// Description: The AlignVideoPortCropBoundary property defines a byte 
//              multiplier used to determine legitimate positions for the 
//              left cropping boundary of the video port. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetAlignVideoPortCropBoundary()
{
return fDDVIDEOPORTCAPS.dwAlignVideoPortCropBoundary;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetAlignVideoPortCropBoundary( dword pAlignVideoPortCropBoundary )
{
fDDVIDEOPORTCAPS.dwAlignVideoPortCropBoundary = pAlignVideoPortCropBoundary;
}
// --------------------------------------------------------------------------
// Property:    AlignVideoPortCropWidth
// Description: The AlignVideoPortCropWidth property defines the width 
//              multiplier used to determine legitimate cropping widths for 
//              the video port. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetAlignVideoPortCropWidth()
{
return fDDVIDEOPORTCAPS.dwAlignVideoPortCropWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetAlignVideoPortCropWidth( dword pAlignVideoPortCropWidth )
{
fDDVIDEOPORTCAPS.dwAlignVideoPortCropWidth = pAlignVideoPortCropWidth;
}
// --------------------------------------------------------------------------
// Property:    AlignVideoPortPrescaleWidth
// Description: The AlignVideoPortPrescaleWidth property defines a width 
//              multiplier used to determine legitimate widths for the video 
//              port, after prescaling. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetAlignVideoPortPrescaleWidth()
{
return fDDVIDEOPORTCAPS.dwAlignVideoPortPrescaleWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetAlignVideoPortPrescaleWidth( dword pAlignVideoPortPrescaleWidth )
{
fDDVIDEOPORTCAPS.dwAlignVideoPortPrescaleWidth = pAlignVideoPortPrescaleWidth;
}
// --------------------------------------------------------------------------
// Property:    Caps
// Description: The Caps property defines flags indicating the available 
//              video port capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPCAPS_AUTOFLIP -
//                Support for flips that are performed automatically when 
//                VREF's occur is available. 
//                This is useful in avoiding tearing. Flips will occur on 
//                every second VREF when the data is being interleaved in 
//                memory. 
//              DDVPCAPS_COLORCONTROL -
//                Support for color control operations being performed on 
//                incoming data before it is written to the frame buffer is 
//                available. 
//              DDVPCAPS_INTERLACED -
//                Support for interlaced video is available. 
//              DDVPCAPS_NONINTERLACED -
//                Support for non interlaced video is available. 
//              DDVPCAPS_OVERSAMPLEDVBI -
//                Support for formats or widths of VBI data that are 
//                different to those of the regular video data is available. 
//              DDVPCAPS_READBACKFIELD -
//                Support for the use of 
//                TDx_DrawVideoPort::GetFieldPolarity() is available. 
//              DDVPCAPS_READBACKLINE -
//                Support for the use of TDx_DrawVideoPort::GetVideoLine() is 
//                available. 
//              DDVPCAPS_SHAREABLE -
//                Support for two genlocked video streams sharing the video 
//                port with one stream using even fields and the other using 
//                odd fields is available. 
//                Separate properties such as address, scaling, cropping, 
//                etc, are maintained for both fields. 
//              DDVPCAPS_SKIPEVENFIELDS -
//                Support for automatically discarding the even fields of a 
//                video signal is available. 
//              DDVPCAPS_SKIPODDFIELDS -
//                Support for automatically discarding the odd fields of a 
//                video signal is available. 
//              DDVPCAPS_SYNCMASTER -
//                Support for driving the display refresh rate with the video 
//                port sync rate is available. 
//              DDVPCAPS_SYSTEMMEMORY -
//                Support for writing to system memory surfaces is available. 
//              DDVPCAPS_VBIANDVIDEOINDEPENDENT -
//                Support for controlling the VBI and video portions of a 
//                video stream with independent processes is available. 
//              DDVPCAPS_VBISURFACE -
//                Support for writing VBI data to a different surface than 
//                the video data is available. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetCaps()
{
return fDDVIDEOPORTCAPS.dwCaps;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetCaps( dword pCaps )
{
fDDVIDEOPORTCAPS.dwCaps = pCaps;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortCaps method or 
//              fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortCaps::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FX
// Description: The FX property defines flags indicating the effects the 
//              video port can support. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPFX_CROPTOPDATA -
//                Support for limited cropping of VBI data is available. 
//              DDVPFX_CROPX -
//                Support for cropping data along the X axis, before it is 
//                written to the surface, is available. 
//              DDVPFX_CROPY -
//                Support for cropping data along the Y axis, before it is 
//                written to the surface, is available. 
//              DDVPFX_IGNOREVBIXCROP -
//                Support for ignoring the X axis cropping coordinates when 
//                cropping oversampled VBI data is available. 
//              DDVPFX_INTERLEAVE -
//                Support for interleaving the interlaced video fields in 
//                memory is available. 
//              DDVPFX_MIRRORLEFTRIGHT -
//                Support for writing video data into the frame buffer, while 
//                mirroring it from left to right, is available. 
//              DDVPFX_MIRRORUPDOWN -
//                Support for writing video data into the frame buffer, while 
//                mirroring it from top to bottom, is available. 
//              DDVPFX_PRESHRINKX -
//                Support for shrinking data along the X axis by an arbitary 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_PRESHRINKXB -
//                Support for the binary shrinking of data along the X axis, 
//                before writing it to the surface, is available. 
//              DDVPFX_PRESHRINKXS -
//                Support for shrinking data along the X axis by increments 
//                of 1/XStep, before writing it to the surface, is available. 
//                The value for XStep is contained in 
//                TDDVideoPortCaps::PreShrinkXStep. 
//              DDVPFX_PRESHRINKY -
//                Support for shrinking data along the Y axis by an arbitary 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_PRESHRINKYB -
//                Support for the binary shrinking of data along the Y axis, 
//                before writing it to the surface, is available. 
//              DDVPFX_PRESHRINKYS -
//                Support for shrinking data along the Y axis by increments 
//                of 1/YStep, before writing it to the surface, is available. 
//                The value for YStep is contained in 
//                TDDVideoPortCaps::PreShrinkYStep. 
//              DDVPFX_PRESTRETCHX -
//                Support for stretching data along the X axis by an arbitary 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_PRESTRETCHXN -
//                Support for stretching data along the X axis by an integer 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_PRESTRETCHY -
//                Support for stretching data along the Y axis by an arbitary 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_PRESTRETCHYN -
//                Support for stretching data along the Y axis by an integer 
//                amount, before writing it to the surface, is available. 
//              DDVPFX_VBICONVERT -
//                Support for converting the VBI data independantly of the 
//                remaining video data is available. 
//              DDVPFX_VBINOINTERLEAVE -
//                Support for disabling interleaving for the VBI data is 
//                available. 
//              DDVPFX_VBINOSCALE -
//                Support for disabling scaling for the VBI data is 
//                available. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetFX()
{
return fDDVIDEOPORTCAPS.dwFX;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetFX( dword pFX )
{
fDDVIDEOPORTCAPS.dwFX = pFX;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating which properties 
//              of this component contain valid data. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPD_ALIGN -
//                TDDVideoPortCaps::AlignVideoPortBoundary, 
//                TDDVideoPortCaps::AlignVideoPortPrescaleWidth, 
//                TDDVideoPortCaps::AlignVideoPortCropBoundary and 
//                TDDVideoPortCaps::AlignVideoPortCropWidth contain valid 
//                data. 
//              DDVPD_AUTOFLIP -
//                TDDVideoPortCaps::NumAutoFlipSurfaces contains valid data. 
//              DDVPD_CAPS -
//                TDDVideoPortCaps::Caps contains valid data. 
//              DDVPD_FILTERQUALITY -
//                TDDVideoPortCaps::NumFilterTapsX and 
//                TDDVideoPortCaps::NumFilterTapsY contain valid data. 
//              DDVPD_FX -
//                TDDVideoPortCaps::FX contains valid data. 
//              DDVPD_HEIGHT -
//                TDDVideoPortCaps::MaxHeight contains valid data. 
//              DDVPD_ID -
//                TDDVideoPortCaps::VideoPortID contains valid data. 
//              DDVPD_PREFERREDAUTOFLIP -
//                TDDVideoPortCaps::NumPreferredAutoflip contains valid data. 
//              DDVPD_WIDTH -
//                TDDVideoPortCaps::MaxWidth contains valid data. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetFlags()
{
return fDDVIDEOPORTCAPS.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetFlags( dword pFlags )
{
fDDVIDEOPORTCAPS.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    MaxHeight
// Description: The MaxHeight property defines the maximum height allowed for 
//              the video port field. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetMaxHeight()
{
return fDDVIDEOPORTCAPS.dwMaxHeight;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetMaxHeight( dword pMaxHeight )
{
fDDVIDEOPORTCAPS.dwMaxHeight = pMaxHeight;
}
// --------------------------------------------------------------------------
// Property:    MaxVBIWidth
// Description: The MaxVBIWidth property defines the maximum width allowed 
//              for the VBI data. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetMaxVBIWidth()
{
return fDDVIDEOPORTCAPS.dwMaxVBIWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetMaxVBIWidth( dword pMaxVBIWidth )
{
fDDVIDEOPORTCAPS.dwMaxVBIWidth = pMaxVBIWidth;
}
// --------------------------------------------------------------------------
// Property:    MaxWidth
// Description: The MaxWidth property defines the maximum width allowed for 
//              the video port field. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetMaxWidth()
{
return fDDVIDEOPORTCAPS.dwMaxWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetMaxWidth( dword pMaxWidth )
{
fDDVIDEOPORTCAPS.dwMaxWidth = pMaxWidth;
}
// --------------------------------------------------------------------------
// Property:    NumAutoFlipSurfaces
// Description: The NumAutoFlipSurfaces property defines the number of 
//              autoflippable surfaces that are supported by the video port. 
//              When autoflipping surfaces are being used a flip will occur 
//              every video port VSYNC unless the signal is being interleaved 
//              in memory, in which case flip will occur every second VSYNC. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetNumAutoFlipSurfaces()
{
return fDDVIDEOPORTCAPS.dwNumAutoFlipSurfaces;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetNumAutoFlipSurfaces( dword pNumAutoFlipSurfaces )
{
fDDVIDEOPORTCAPS.dwNumAutoFlipSurfaces = pNumAutoFlipSurfaces;
}
// --------------------------------------------------------------------------
// Property:    NumFilterTapsX
// Description: The NumFilterTapsX property defines the number of taps used 
//              by the prescaler filter along the X axis. 
//              0 indicates no prescaling, 1 indicates the prescaler performs 
//              replication, 2 indicates the prescaler uses two taps and so 
//              on. 
// --------------------------------------------------------------------------
word __fastcall TDDVideoPortCaps::FGetNumFilterTapsX()
{
return fDDVIDEOPORTCAPS.wNumFilterTapsX;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetNumFilterTapsX( word pNumFilterTapsX )
{
fDDVIDEOPORTCAPS.wNumFilterTapsX = pNumFilterTapsX;
}
// --------------------------------------------------------------------------
// Property:    NumFilterTapsY
// Description: The NumFilterTapsY property defines the number of taps used 
//              by the prescaler filter along the Y axis. 
//              0 indicates no prescaling, 1 indicates the prescaler performs 
//              replication, 2 indicates the prescaler uses two taps and so 
//              on. 
// --------------------------------------------------------------------------
word __fastcall TDDVideoPortCaps::FGetNumFilterTapsY()
{
return fDDVIDEOPORTCAPS.wNumFilterTapsY;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetNumFilterTapsY( word pNumFilterTapsY )
{
fDDVIDEOPORTCAPS.wNumFilterTapsY = pNumFilterTapsY;
}
// --------------------------------------------------------------------------
// Property:    NumPreferredAutoflip
// Description: The NumPreferredAutoFlip property defines the optimum number 
//              of autoflippable surfaces supported. 
//              When autoflipping is being used a flip will occur every video 
//              port VSYNC unless the signal is being interleaved in memory, 
//              in which case a flip will occur every second VSYNC. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetNumPreferredAutoflip()
{
return fDDVIDEOPORTCAPS.dwNumPreferredAutoflip;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetNumPreferredAutoflip( dword pNumPreferredAutoflip )
{
fDDVIDEOPORTCAPS.dwNumPreferredAutoflip = pNumPreferredAutoflip;
}
// --------------------------------------------------------------------------
// Property:    NumVBIAutoFlipSurfaces
// Description: The NumVBIAutoFlipSurfaces property defines the number of 
//              autoflippable surfaces capable of recieving VBI data that are 
//              supported by the video port. 
//              When autoflipping is being used a flip will occur every video 
//              port VSYNC unless the signal is being interleaved in memory, 
//              in which case a flip will occur every second VSYNC. 
//              The number of VBI surfaces in the flip chain must equal the 
//              number of surfaces receiving the rest of the video data. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetNumVBIAutoFlipSurfaces()
{
return fDDVIDEOPORTCAPS.dwNumVBIAutoFlipSurfaces;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetNumVBIAutoFlipSurfaces( dword pNumVBIAutoFlipSurfaces )
{
fDDVIDEOPORTCAPS.dwNumVBIAutoFlipSurfaces = pNumVBIAutoFlipSurfaces;
}
// --------------------------------------------------------------------------
// Property:    PreshrinkXStep
// Description: The PreshrinkXStep property defines the value used for 
//              shrinking data along the X axis when TDDVideoPortCaps::FX has 
//              the DDVPFX_PRESHRINKXS flag set. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetPreshrinkXStep()
{
return fDDVIDEOPORTCAPS.dwPreshrinkXStep;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetPreshrinkXStep( dword pPreshrinkXStep )
{
fDDVIDEOPORTCAPS.dwPreshrinkXStep = pPreshrinkXStep;
}
// --------------------------------------------------------------------------
// Property:    PreshrinkYStep
// Description: The PreshrinkYStep property defines the value used for 
//              shrinking data along the Y axis when TDDVideoPortCaps::FX has 
//              the DDVPFX_PRESHRINKYS flag set. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetPreshrinkYStep()
{
return fDDVIDEOPORTCAPS.dwPreshrinkYStep;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetPreshrinkYStep( dword pPreshrinkYStep )
{
fDDVIDEOPORTCAPS.dwPreshrinkYStep = pPreshrinkYStep;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetSize()
{
return fDDVIDEOPORTCAPS.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetSize( dword pSize )
{
fDDVIDEOPORTCAPS.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    VideoPortID
// Description: The VideoPortID property uniquely identifies the video port 
//              to the system. 
//              This property will contain an integer value between 0 and 
//              TDDVideoPortCaps::MaxVideoPorts minus one. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortCaps::FGetVideoPortID()
{
return fDDVIDEOPORTCAPS.dwVideoPortID;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetVideoPortID( dword pVideoPortID )
{
fDDVIDEOPORTCAPS.dwVideoPortID = pVideoPortID;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortCaps's internal DDVIDEOPORTCAPS structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::Clear()
{
fDDVIDEOPORTCAPS.dwAlignVideoPortBoundary = 0;
fDDVIDEOPORTCAPS.dwAlignVideoPortCropBoundary = 0;
fDDVIDEOPORTCAPS.dwAlignVideoPortCropWidth = 0;
fDDVIDEOPORTCAPS.dwAlignVideoPortPrescaleWidth = 0;
fDDVIDEOPORTCAPS.dwCaps = 0;
fErrorValue = DD_OK;
fDDVIDEOPORTCAPS.dwFX = 0;
fDDVIDEOPORTCAPS.dwFlags = 0;
fDDVIDEOPORTCAPS.dwMaxHeight = 0;
fDDVIDEOPORTCAPS.dwMaxVBIWidth = 0;
fDDVIDEOPORTCAPS.dwMaxWidth = 0;
fDDVIDEOPORTCAPS.dwNumAutoFlipSurfaces = 0;
fDDVIDEOPORTCAPS.wNumFilterTapsX = 0;
fDDVIDEOPORTCAPS.wNumFilterTapsY = 0;
fDDVIDEOPORTCAPS.dwNumPreferredAutoflip = 0;
fDDVIDEOPORTCAPS.dwNumVBIAutoFlipSurfaces = 0;
fDDVIDEOPORTCAPS.dwPreshrinkXStep = 0;
fDDVIDEOPORTCAPS.dwPreshrinkYStep = 0;
fDDVIDEOPORTCAPS.dwSize = sizeof(DDVIDEOPORTCAPS);
fDDVIDEOPORTCAPS.dwVideoPortID = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDVIDEOPORTCAPS* __fastcall TDDVideoPortCaps::FGetInternal_DDVIDEOPORTCAPS_Ptr()
{
return &fDDVIDEOPORTCAPS;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetInternal_DDVIDEOPORTCAPS( DDVIDEOPORTCAPS* pDDVIDEOPORTCAPS )
{
if (pDDVIDEOPORTCAPS==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortCaps::FSetInternal_DDVIDEOPORTCAPS()", "TDX_ERROR", "The supplied DDVIDEOPORTCAPS* was NULL" );
    return;
    }

CopyMemory( &fDDVIDEOPORTCAPS, pDDVIDEOPORTCAPS, sizeof(DDVIDEOPORTCAPS) );
Internal_DDVIDEOPORTCAPS_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::Internal_DDVIDEOPORTCAPS_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetCaps_
// Description: This method returns a TDDVideoPortCaps_Caps_Set<> of the 
//              flags in the current fDDVIDEOPORTCAPS.dwCaps. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortCaps_Caps_Set __fastcall TDDVideoPortCaps::FGetCaps_()
{
TDDVideoPortCaps_Caps_Set TempCaps_;
TempCaps_.Clear();
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_AUTOFLIP) TempCaps_ = TempCaps_ << ddvpcaps_autoflip;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_COLORCONTROL) TempCaps_ = TempCaps_ << ddvpcaps_colorcontrol;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_INTERLACED) TempCaps_ = TempCaps_ << ddvpcaps_interlaced;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_NONINTERLACED) TempCaps_ = TempCaps_ << ddvpcaps_noninterlaced;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_OVERSAMPLEDVBI) TempCaps_ = TempCaps_ << ddvpcaps_oversampledvbi;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_READBACKFIELD) TempCaps_ = TempCaps_ << ddvpcaps_readbackfield;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_READBACKLINE) TempCaps_ = TempCaps_ << ddvpcaps_readbackline;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SHAREABLE) TempCaps_ = TempCaps_ << ddvpcaps_shareable;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SKIPEVENFIELDS) TempCaps_ = TempCaps_ << ddvpcaps_skipevenfields;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SKIPODDFIELDS) TempCaps_ = TempCaps_ << ddvpcaps_skipoddfields;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SYNCMASTER) TempCaps_ = TempCaps_ << ddvpcaps_syncmaster;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SYSTEMMEMORY) TempCaps_ = TempCaps_ << ddvpcaps_systemmemory;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_VBIANDVIDEOINDEPENDENT) TempCaps_ = TempCaps_ << ddvpcaps_vbiandvideoindependent;
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_VBISURFACE) TempCaps_ = TempCaps_ << ddvpcaps_vbisurface;
return TempCaps_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetCaps_( TDDVideoPortCaps_Caps_Set pCaps_ )
{
fDDVIDEOPORTCAPS.dwCaps = 0;
if (pCaps_.Contains(ddvpcaps_autoflip)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_AUTOFLIP;
if (pCaps_.Contains(ddvpcaps_colorcontrol)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_COLORCONTROL;
if (pCaps_.Contains(ddvpcaps_interlaced)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_INTERLACED;
if (pCaps_.Contains(ddvpcaps_noninterlaced)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_NONINTERLACED;
if (pCaps_.Contains(ddvpcaps_oversampledvbi)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_OVERSAMPLEDVBI;
if (pCaps_.Contains(ddvpcaps_readbackfield)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_READBACKFIELD;
if (pCaps_.Contains(ddvpcaps_readbackline)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_READBACKLINE;
if (pCaps_.Contains(ddvpcaps_shareable)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_SHAREABLE;
if (pCaps_.Contains(ddvpcaps_skipevenfields)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_SKIPEVENFIELDS;
if (pCaps_.Contains(ddvpcaps_skipoddfields)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_SKIPODDFIELDS;
if (pCaps_.Contains(ddvpcaps_syncmaster)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_SYNCMASTER;
if (pCaps_.Contains(ddvpcaps_systemmemory)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_SYSTEMMEMORY;
if (pCaps_.Contains(ddvpcaps_vbiandvideoindependent)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_VBIANDVIDEOINDEPENDENT;
if (pCaps_.Contains(ddvpcaps_vbisurface)) fDDVIDEOPORTCAPS.dwCaps |= DDVPCAPS_VBISURFACE;
}
// --------------------------------------------------------------------------
// Method:      FGetCaps_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Caps' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortCaps::FGetCaps_Strings()
{
// if the strings have not been allocated
if (fCaps_Strings==NULL)
    {
    // attempt to allocate the strings
    fCaps_Strings = new TStringList();
    // if the allocation failed
    if (fCaps_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortCaps::FGetCaps_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Caps_Strings" );
        return NULL;
        }
    }
fCaps_Strings->Clear();
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_AUTOFLIP) fCaps_Strings->Add("DDVPCAPS_AUTOFLIP");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_COLORCONTROL) fCaps_Strings->Add("DDVPCAPS_COLORCONTROL");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_INTERLACED) fCaps_Strings->Add("DDVPCAPS_INTERLACED");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_NONINTERLACED) fCaps_Strings->Add("DDVPCAPS_NONINTERLACED");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_OVERSAMPLEDVBI) fCaps_Strings->Add("DDVPCAPS_OVERSAMPLEDVBI");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_READBACKFIELD) fCaps_Strings->Add("DDVPCAPS_READBACKFIELD");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_READBACKLINE) fCaps_Strings->Add("DDVPCAPS_READBACKLINE");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SHAREABLE) fCaps_Strings->Add("DDVPCAPS_SHAREABLE");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SKIPEVENFIELDS) fCaps_Strings->Add("DDVPCAPS_SKIPEVENFIELDS");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SKIPODDFIELDS) fCaps_Strings->Add("DDVPCAPS_SKIPODDFIELDS");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SYNCMASTER) fCaps_Strings->Add("DDVPCAPS_SYNCMASTER");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_SYSTEMMEMORY) fCaps_Strings->Add("DDVPCAPS_SYSTEMMEMORY");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_VBIANDVIDEOINDEPENDENT) fCaps_Strings->Add("DDVPCAPS_VBIANDVIDEOINDEPENDENT");
if (fDDVIDEOPORTCAPS.dwCaps & DDVPCAPS_VBISURFACE) fCaps_Strings->Add("DDVPCAPS_VBISURFACE");
return fCaps_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetFX_
// Description: This method returns a TDDVideoPortCaps_FX_Set<> of the flags 
//              in the current fDDVIDEOPORTCAPS.dwFX. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortCaps_FX_Set __fastcall TDDVideoPortCaps::FGetFX_()
{
TDDVideoPortCaps_FX_Set TempFX_;
TempFX_.Clear();
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPTOPDATA) TempFX_ = TempFX_ << ddvpfx_croptopdata;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPX) TempFX_ = TempFX_ << ddvpfx_cropx;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPY) TempFX_ = TempFX_ << ddvpfx_cropy;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_IGNOREVBIXCROP) TempFX_ = TempFX_ << ddvpfx_ignorevbixcrop;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_INTERLEAVE) TempFX_ = TempFX_ << ddvpfx_interleave;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_MIRRORLEFTRIGHT) TempFX_ = TempFX_ << ddvpfx_mirrorleftright;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_MIRRORUPDOWN) TempFX_ = TempFX_ << ddvpfx_mirrorupdown;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKX) TempFX_ = TempFX_ << ddvpfx_preshrinkx;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKXB) TempFX_ = TempFX_ << ddvpfx_preshrinkxb;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKXS) TempFX_ = TempFX_ << ddvpfx_preshrinkxs;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKY) TempFX_ = TempFX_ << ddvpfx_preshrinky;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKYB) TempFX_ = TempFX_ << ddvpfx_preshrinkyb;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKYS) TempFX_ = TempFX_ << ddvpfx_preshrinkys;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHX) TempFX_ = TempFX_ << ddvpfx_prestretchx;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHXN) TempFX_ = TempFX_ << ddvpfx_prestretchxn;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHY) TempFX_ = TempFX_ << ddvpfx_prestretchy;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHYN) TempFX_ = TempFX_ << ddvpfx_prestretchyn;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBICONVERT) TempFX_ = TempFX_ << ddvpfx_vbiconvert;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBINOINTERLEAVE) TempFX_ = TempFX_ << ddvpfx_vbinointerleave;
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBINOSCALE) TempFX_ = TempFX_ << ddvpfx_vbinoscale;
return TempFX_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetFX_( TDDVideoPortCaps_FX_Set pFX_ )
{
fDDVIDEOPORTCAPS.dwFX = 0;
if (pFX_.Contains(ddvpfx_croptopdata)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_CROPTOPDATA;
if (pFX_.Contains(ddvpfx_cropx)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_CROPX;
if (pFX_.Contains(ddvpfx_cropy)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_CROPY;
if (pFX_.Contains(ddvpfx_ignorevbixcrop)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_IGNOREVBIXCROP;
if (pFX_.Contains(ddvpfx_interleave)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_INTERLEAVE;
if (pFX_.Contains(ddvpfx_mirrorleftright)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_MIRRORLEFTRIGHT;
if (pFX_.Contains(ddvpfx_mirrorupdown)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_MIRRORUPDOWN;
if (pFX_.Contains(ddvpfx_preshrinkx)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKX;
if (pFX_.Contains(ddvpfx_preshrinkxb)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKXB;
if (pFX_.Contains(ddvpfx_preshrinkxs)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKXS;
if (pFX_.Contains(ddvpfx_preshrinky)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKY;
if (pFX_.Contains(ddvpfx_preshrinkyb)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKYB;
if (pFX_.Contains(ddvpfx_preshrinkys)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESHRINKYS;
if (pFX_.Contains(ddvpfx_prestretchx)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESTRETCHX;
if (pFX_.Contains(ddvpfx_prestretchxn)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESTRETCHXN;
if (pFX_.Contains(ddvpfx_prestretchy)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESTRETCHY;
if (pFX_.Contains(ddvpfx_prestretchyn)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_PRESTRETCHYN;
if (pFX_.Contains(ddvpfx_vbiconvert)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_VBICONVERT;
if (pFX_.Contains(ddvpfx_vbinointerleave)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_VBINOINTERLEAVE;
if (pFX_.Contains(ddvpfx_vbinoscale)) fDDVIDEOPORTCAPS.dwFX |= DDVPFX_VBINOSCALE;
}
// --------------------------------------------------------------------------
// Method:      FGetFX_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'FX' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortCaps::FGetFX_Strings()
{
// if the strings have not been allocated
if (fFX_Strings==NULL)
    {
    // attempt to allocate the strings
    fFX_Strings = new TStringList();
    // if the allocation failed
    if (fFX_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortCaps::FGetFX_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various FX_Strings" );
        return NULL;
        }
    }
fFX_Strings->Clear();
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPTOPDATA) fFX_Strings->Add("DDVPFX_CROPTOPDATA");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPX) fFX_Strings->Add("DDVPFX_CROPX");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_CROPY) fFX_Strings->Add("DDVPFX_CROPY");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_IGNOREVBIXCROP) fFX_Strings->Add("DDVPFX_IGNOREVBIXCROP");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_INTERLEAVE) fFX_Strings->Add("DDVPFX_INTERLEAVE");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_MIRRORLEFTRIGHT) fFX_Strings->Add("DDVPFX_MIRRORLEFTRIGHT");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_MIRRORUPDOWN) fFX_Strings->Add("DDVPFX_MIRRORUPDOWN");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKX) fFX_Strings->Add("DDVPFX_PRESHRINKX");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKXB) fFX_Strings->Add("DDVPFX_PRESHRINKXB");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKXS) fFX_Strings->Add("DDVPFX_PRESHRINKXS");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKY) fFX_Strings->Add("DDVPFX_PRESHRINKY");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKYB) fFX_Strings->Add("DDVPFX_PRESHRINKYB");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESHRINKYS) fFX_Strings->Add("DDVPFX_PRESHRINKYS");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHX) fFX_Strings->Add("DDVPFX_PRESTRETCHX");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHXN) fFX_Strings->Add("DDVPFX_PRESTRETCHXN");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHY) fFX_Strings->Add("DDVPFX_PRESTRETCHY");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_PRESTRETCHYN) fFX_Strings->Add("DDVPFX_PRESTRETCHYN");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBICONVERT) fFX_Strings->Add("DDVPFX_VBICONVERT");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBINOINTERLEAVE) fFX_Strings->Add("DDVPFX_VBINOINTERLEAVE");
if (fDDVIDEOPORTCAPS.dwFX & DDVPFX_VBINOSCALE) fFX_Strings->Add("DDVPFX_VBINOSCALE");
return fFX_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDVideoPortCaps_Flags_Set<> of the 
//              flags in the current fDDVIDEOPORTCAPS.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortCaps_Flags_Set __fastcall TDDVideoPortCaps::FGetFlags_()
{
TDDVideoPortCaps_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_ALIGN) TempFlags_ = TempFlags_ << ddvpd_align;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_AUTOFLIP) TempFlags_ = TempFlags_ << ddvpd_autoflip;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_CAPS) TempFlags_ = TempFlags_ << ddvpd_caps;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_FILTERQUALITY) TempFlags_ = TempFlags_ << ddvpd_filterquality;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_FX) TempFlags_ = TempFlags_ << ddvpd_fx;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_HEIGHT) TempFlags_ = TempFlags_ << ddvpd_height;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_ID) TempFlags_ = TempFlags_ << ddvpd_id;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_PREFERREDAUTOFLIP) TempFlags_ = TempFlags_ << ddvpd_preferredautoflip;
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_WIDTH) TempFlags_ = TempFlags_ << ddvpd_width;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortCaps::FSetFlags_( TDDVideoPortCaps_Flags_Set pFlags_ )
{
fDDVIDEOPORTCAPS.dwFlags = 0;
if (pFlags_.Contains(ddvpd_align)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_ALIGN;
if (pFlags_.Contains(ddvpd_autoflip)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_AUTOFLIP;
if (pFlags_.Contains(ddvpd_caps)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_CAPS;
if (pFlags_.Contains(ddvpd_filterquality)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_FILTERQUALITY;
if (pFlags_.Contains(ddvpd_fx)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_FX;
if (pFlags_.Contains(ddvpd_height)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_HEIGHT;
if (pFlags_.Contains(ddvpd_id)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_ID;
if (pFlags_.Contains(ddvpd_preferredautoflip)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_PREFERREDAUTOFLIP;
if (pFlags_.Contains(ddvpd_width)) fDDVIDEOPORTCAPS.dwFlags |= DDVPD_WIDTH;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortCaps::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortCaps::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_ALIGN) fFlags_Strings->Add("DDVPD_ALIGN");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_AUTOFLIP) fFlags_Strings->Add("DDVPD_AUTOFLIP");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_CAPS) fFlags_Strings->Add("DDVPD_CAPS");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_FILTERQUALITY) fFlags_Strings->Add("DDVPD_FILTERQUALITY");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_FX) fFlags_Strings->Add("DDVPD_FX");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_HEIGHT) fFlags_Strings->Add("DDVPD_HEIGHT");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_ID) fFlags_Strings->Add("DDVPD_ID");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_PREFERREDAUTOFLIP) fFlags_Strings->Add("DDVPD_PREFERREDAUTOFLIP");
if (fDDVIDEOPORTCAPS.dwFlags & DDVPD_WIDTH) fFlags_Strings->Add("DDVPD_WIDTH");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
