// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortInfo.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortInfo 
//               Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortInfo.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortInfo*)
{
    new TDDVideoPortInfo(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportinfo
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortInfo)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortInfo::TDDVideoPortInfo()
// Description: The default constructor for the TDDVideoPortInfo object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortInfo::TDDVideoPortInfo(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fVPFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortInfo::~TDDVideoPortInfo()
// Description: The destructor for the TDDVideoPortInfo object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortInfo::~TDDVideoPortInfo()
{
if (fVPFlags_Strings!=NULL) delete fVPFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    Crop
// Description: The Crop property references a TRect defining the rectangle 
//              used for cropping video data. 
//              This property is optional. 
// --------------------------------------------------------------------------
TRect __fastcall TDDVideoPortInfo::FGetCrop()
{
TRect TempCrop;
TempCrop.Top = fDDVIDEOPORTINFO.rCrop.top;
TempCrop.Left = fDDVIDEOPORTINFO.rCrop.left;
TempCrop.Right = fDDVIDEOPORTINFO.rCrop.right;
TempCrop.Bottom = fDDVIDEOPORTINFO.rCrop.bottom;
return TempCrop;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetCrop( TRect pCrop )
{
fDDVIDEOPORTINFO.rCrop.top = pCrop.Top;
fDDVIDEOPORTINFO.rCrop.left = pCrop.Left;
fDDVIDEOPORTINFO.rCrop.right = pCrop.Right;
fDDVIDEOPORTINFO.rCrop.bottom = pCrop.Bottom;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortInfo method or 
//              fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortInfo::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    InputFormat
// Description: The InputFormat property references a TDDPixelFormat 
//              component describing the pixel format that will be written to 
//              the video port. 
//              This is usually identical to the surface's pixel format but 
//              may differ if the video port is set perform conversion by 
//              setting the corresponding TDDVideoPortInfo::VPFlags values. 
// --------------------------------------------------------------------------
TDDPixelFormat* __fastcall TDDVideoPortInfo::FGetInputFormat()
{
if (ComponentState.Contains(csDesigning) &&
    (fInputFormat!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fInputFormat)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fInputFormat=NULL;
    }
return fInputFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetInputFormat( TDDPixelFormat* pInputFormat )
{
fInputFormat = pInputFormat;
fDDVIDEOPORTINFO.lpddpfInputFormat = pInputFormat->Internal_DDPIXELFORMAT_Ptr;
}
// --------------------------------------------------------------------------
// Property:    OriginX
// Description: The OriginX property defines the X coordinate indicating 
//              where to start feeding video data to a surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetOriginX()
{
return fDDVIDEOPORTINFO.dwOriginX;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetOriginX( dword pOriginX )
{
fDDVIDEOPORTINFO.dwOriginX = pOriginX;
}
// --------------------------------------------------------------------------
// Property:    OriginY
// Description: The OriginY property defines the Y coordinate indicating 
//              where to start feeding video data to a surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetOriginY()
{
return fDDVIDEOPORTINFO.dwOriginY;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetOriginY( dword pOriginY )
{
fDDVIDEOPORTINFO.dwOriginY = pOriginY;
}
// --------------------------------------------------------------------------
// Property:    PrescaleHeight
// Description: The PrescaleHeight property defines how much pre-scaling or 
//              zooming, along the Y axis, is to be done before writing the 
//              video data to a surface. 
//              This property is optional. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetPrescaleHeight()
{
return fDDVIDEOPORTINFO.dwPrescaleHeight;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetPrescaleHeight( dword pPrescaleHeight )
{
fDDVIDEOPORTINFO.dwPrescaleHeight = pPrescaleHeight;
}
// --------------------------------------------------------------------------
// Property:    PrescaleWidth
// Description: The PrescaleWidth property defines how much pre-scaling or 
//              zooming, along the X axis, is to be done before writing the 
//              video data to a surface. 
//              This property is optional. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetPrescaleWidth()
{
return fDDVIDEOPORTINFO.dwPrescaleWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetPrescaleWidth( dword pPrescaleWidth )
{
fDDVIDEOPORTINFO.dwPrescaleWidth = pPrescaleWidth;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetSize()
{
return fDDVIDEOPORTINFO.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetSize( dword pSize )
{
fDDVIDEOPORTINFO.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    VBIHeight
// Description: The VBIHeight property defines the amount of data, in scan 
//              lines, within the VBI. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetVBIHeight()
{
return fDDVIDEOPORTINFO.dwVBIHeight;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetVBIHeight( dword pVBIHeight )
{
fDDVIDEOPORTINFO.dwVBIHeight = pVBIHeight;
}
// --------------------------------------------------------------------------
// Property:    VBIInputFormat
// Description: The VBIInputFormat property references a TDDPixelFormat 
//              component describing the pixel format that will be written to 
//              a surface. 
//              This is usually identical to the input pixel format but may 
//              differ if the video port is set perform conversion by setting 
//              the corresponding TDDVideoPortInfo::VPFlags values. 
// --------------------------------------------------------------------------
TDDPixelFormat* __fastcall TDDVideoPortInfo::FGetVBIInputFormat()
{
if (ComponentState.Contains(csDesigning) &&
    (fVBIInputFormat!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fVBIInputFormat)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fVBIInputFormat=NULL;
    }
return fVBIInputFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetVBIInputFormat( TDDPixelFormat* pVBIInputFormat )
{
fVBIInputFormat = pVBIInputFormat;
fDDVIDEOPORTINFO.lpddpfVBIInputFormat = pVBIInputFormat->Internal_DDPIXELFORMAT_Ptr;
}
// --------------------------------------------------------------------------
// Property:    VBIOutputFormat
// Description: The VBIOutputFormat property references a TDDPixelFormat 
//              component describing the output pixel format of the data 
//              contained within the VBI of the video stream. 
// --------------------------------------------------------------------------
TDDPixelFormat* __fastcall TDDVideoPortInfo::FGetVBIOutputFormat()
{
if (ComponentState.Contains(csDesigning) &&
    (fVBIOutputFormat!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fVBIOutputFormat)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fVBIOutputFormat=NULL;
    }
return fVBIOutputFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetVBIOutputFormat( TDDPixelFormat* pVBIOutputFormat )
{
fVBIOutputFormat = pVBIOutputFormat;
fDDVIDEOPORTINFO.lpddpfVBIOutputFormat = pVBIOutputFormat->Internal_DDPIXELFORMAT_Ptr;
}
// --------------------------------------------------------------------------
// Property:    VPFlags
// Description: The VPFlags property defines flags indicating what video port 
//              options are to be utilized when transferring data to a 
//              surface. 
//              The described effect applies when the flag is set. 
// Flags:       DDVP_AUTOFLIP -
//                Autoflip to the next destination overlay surface in the 
//                flip chain as each VREF occurs. 
//                Flips will occur every VREF unless the fields are being 
//                interleaved in memory, in which case flips will occur every 
//                second VREF. 
//              DDVP_CONVERT -
//                Video data is to be color converted before it is written to 
//                a surface by using the pixel format information referenced 
//                by TDDVideoPortInfo::OutputFormat. 
//              DDVP_CROP -
//                Video data is to be cropped using the rectangle referenced 
//                by TDDVideoPortInfo::Crop, before writing it to a surface 
//              DDVP_IGNOREVBIXCROP -
//                X axis cropping coordinates are to be ignored when cropping 
//                oversampled VBI data. 
//              DDVP_INTERLEAVE -
//                Interlaced fields are to be interleaved in memory. 
//              DDVP_MIRRORLEFTRIGHT -
//                Image data is to be irrorred from left to right when 
//                writing to the frame buffer. 
//              DDVP_MIRRORUPDOWN -
//                Image data is to be mirrorred from top to bottom when 
//                writing it to the frame buffer. 
//              DDVP_OVERRIDEBOBWEAVE -
//                Override any automatic display methods chosen by the driver 
//                and use only the display method set by the caller when they 
//                created the overlay surface. 
//              DDVP_PRESCALE -
//                Pre-scale or zoom the video data based on the values in 
//                TDDVideoPortInfo::PrescaleHeight and 
//                TDDVideoPortInfo::PrescaleWidth. 
//              DDVP_SKIPEVENFIELDS -
//                Ignore the even field of the video frames. 
//              DDVP_SKIPODDFIELDS -
//                Ignore the odd field of the video frames. 
//              DDVP_SYNCMASTER -
//                Lock the graphics refresh rate to the video port by using 
//                the video port VREF as the graphics VREF. 
//              DDVP_VBICONVERT -
//                Convert VBI data contained in the video stream using the 
//                pixel format information contained in 
//                TDDVideoPortInfo::VBIOutputFormat. 
//              DDVP_VBINOINTERLEAVE -
//                Disable interleaving in memory for data contained within 
//                the VBI. 
//              DDVP_VBINOSCALE -
//                Do not perform any scaling on VBI data contained within the 
//                video stream. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortInfo::FGetVPFlags()
{
return fDDVIDEOPORTINFO.dwVPFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetVPFlags( dword pVPFlags )
{
fDDVIDEOPORTINFO.dwVPFlags = pVPFlags;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortInfo's internal DDVIDEOPORTINFO structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::Clear()
{
fDDVIDEOPORTINFO.rCrop.top=0;
fDDVIDEOPORTINFO.rCrop.left=0;
fDDVIDEOPORTINFO.rCrop.right=0;
fDDVIDEOPORTINFO.rCrop.bottom=0;
fErrorValue = DD_OK;
fInputFormat = NULL;
fDDVIDEOPORTINFO.lpddpfInputFormat = NULL;
fDDVIDEOPORTINFO.dwOriginX = 0;
fDDVIDEOPORTINFO.dwOriginY = 0;
fDDVIDEOPORTINFO.dwPrescaleHeight = 0;
fDDVIDEOPORTINFO.dwPrescaleWidth = 0;
fDDVIDEOPORTINFO.dwSize = sizeof(DDVIDEOPORTINFO);
fDDVIDEOPORTINFO.dwVBIHeight = 0;
fVBIInputFormat = NULL;
fDDVIDEOPORTINFO.lpddpfVBIInputFormat = NULL;
fVBIOutputFormat = NULL;
fDDVIDEOPORTINFO.lpddpfVBIOutputFormat = NULL;
fDDVIDEOPORTINFO.dwVPFlags = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDVIDEOPORTINFO* __fastcall TDDVideoPortInfo::FGetInternal_DDVIDEOPORTINFO_Ptr()
{
return &fDDVIDEOPORTINFO;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetInternal_DDVIDEOPORTINFO( DDVIDEOPORTINFO* pDDVIDEOPORTINFO )
{
if (pDDVIDEOPORTINFO==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortInfo::FSetInternal_DDVIDEOPORTINFO()", "TDX_ERROR", "The supplied DDVIDEOPORTINFO* was NULL" );
    return;
    }

CopyMemory( &fDDVIDEOPORTINFO, pDDVIDEOPORTINFO, sizeof(DDVIDEOPORTINFO) );
Internal_DDVIDEOPORTINFO_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::Internal_DDVIDEOPORTINFO_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetVPFlags_
// Description: This method returns a TDDVideoPortInfo_VPFlags_Set<> of the 
//              flags in the current fDDVIDEOPORTINFO.dwVPFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortInfo_VPFlags_Set __fastcall TDDVideoPortInfo::FGetVPFlags_()
{
TDDVideoPortInfo_VPFlags_Set TempVPFlags_;
TempVPFlags_.Clear();
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_AUTOFLIP) TempVPFlags_ = TempVPFlags_ << ddvp_autoflip;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_CONVERT) TempVPFlags_ = TempVPFlags_ << ddvp_convert;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_CROP) TempVPFlags_ = TempVPFlags_ << ddvp_crop;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_IGNOREVBIXCROP) TempVPFlags_ = TempVPFlags_ << ddvp_ignorevbixcrop;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_INTERLEAVE) TempVPFlags_ = TempVPFlags_ << ddvp_interleave;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_MIRRORLEFTRIGHT) TempVPFlags_ = TempVPFlags_ << ddvp_mirrorleftright;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_MIRRORUPDOWN) TempVPFlags_ = TempVPFlags_ << ddvp_mirrorupdown;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_OVERRIDEBOBWEAVE) TempVPFlags_ = TempVPFlags_ << ddvp_overridebobweave;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_PRESCALE) TempVPFlags_ = TempVPFlags_ << ddvp_prescale;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SKIPEVENFIELDS) TempVPFlags_ = TempVPFlags_ << ddvp_skipevenfields;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SKIPODDFIELDS) TempVPFlags_ = TempVPFlags_ << ddvp_skipoddfields;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SYNCMASTER) TempVPFlags_ = TempVPFlags_ << ddvp_syncmaster;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBICONVERT) TempVPFlags_ = TempVPFlags_ << ddvp_vbiconvert;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBINOINTERLEAVE) TempVPFlags_ = TempVPFlags_ << ddvp_vbinointerleave;
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBINOSCALE) TempVPFlags_ = TempVPFlags_ << ddvp_vbinoscale;
return TempVPFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortInfo::FSetVPFlags_( TDDVideoPortInfo_VPFlags_Set pVPFlags_ )
{
fDDVIDEOPORTINFO.dwVPFlags = 0;
if (pVPFlags_.Contains(ddvp_autoflip)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_AUTOFLIP;
if (pVPFlags_.Contains(ddvp_convert)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_CONVERT;
if (pVPFlags_.Contains(ddvp_crop)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_CROP;
if (pVPFlags_.Contains(ddvp_ignorevbixcrop)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_IGNOREVBIXCROP;
if (pVPFlags_.Contains(ddvp_interleave)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_INTERLEAVE;
if (pVPFlags_.Contains(ddvp_mirrorleftright)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_MIRRORLEFTRIGHT;
if (pVPFlags_.Contains(ddvp_mirrorupdown)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_MIRRORUPDOWN;
if (pVPFlags_.Contains(ddvp_overridebobweave)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_OVERRIDEBOBWEAVE;
if (pVPFlags_.Contains(ddvp_prescale)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_PRESCALE;
if (pVPFlags_.Contains(ddvp_skipevenfields)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_SKIPEVENFIELDS;
if (pVPFlags_.Contains(ddvp_skipoddfields)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_SKIPODDFIELDS;
if (pVPFlags_.Contains(ddvp_syncmaster)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_SYNCMASTER;
if (pVPFlags_.Contains(ddvp_vbiconvert)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_VBICONVERT;
if (pVPFlags_.Contains(ddvp_vbinointerleave)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_VBINOINTERLEAVE;
if (pVPFlags_.Contains(ddvp_vbinoscale)) fDDVIDEOPORTINFO.dwVPFlags |= DDVP_VBINOSCALE;
}
// --------------------------------------------------------------------------
// Method:      FGetVPFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'VPFlags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortInfo::FGetVPFlags_Strings()
{
// if the strings have not been allocated
if (fVPFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fVPFlags_Strings = new TStringList();
    // if the allocation failed
    if (fVPFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortInfo::FGetVPFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various VPFlags_Strings" );
        return NULL;
        }
    }
fVPFlags_Strings->Clear();
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_AUTOFLIP) fVPFlags_Strings->Add("DDVP_AUTOFLIP");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_CONVERT) fVPFlags_Strings->Add("DDVP_CONVERT");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_CROP) fVPFlags_Strings->Add("DDVP_CROP");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_IGNOREVBIXCROP) fVPFlags_Strings->Add("DDVP_IGNOREVBIXCROP");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_INTERLEAVE) fVPFlags_Strings->Add("DDVP_INTERLEAVE");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_MIRRORLEFTRIGHT) fVPFlags_Strings->Add("DDVP_MIRRORLEFTRIGHT");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_MIRRORUPDOWN) fVPFlags_Strings->Add("DDVP_MIRRORUPDOWN");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_OVERRIDEBOBWEAVE) fVPFlags_Strings->Add("DDVP_OVERRIDEBOBWEAVE");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_PRESCALE) fVPFlags_Strings->Add("DDVP_PRESCALE");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SKIPEVENFIELDS) fVPFlags_Strings->Add("DDVP_SKIPEVENFIELDS");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SKIPODDFIELDS) fVPFlags_Strings->Add("DDVP_SKIPODDFIELDS");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_SYNCMASTER) fVPFlags_Strings->Add("DDVP_SYNCMASTER");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBICONVERT) fVPFlags_Strings->Add("DDVP_VBICONVERT");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBINOINTERLEAVE) fVPFlags_Strings->Add("DDVP_VBINOINTERLEAVE");
if (fDDVIDEOPORTINFO.dwVPFlags & DDVP_VBINOSCALE) fVPFlags_Strings->Add("DDVP_VBINOSCALE");
return fVPFlags_Strings;
}
// --------------------------------------------------------------------------
