// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_DrawColorControl.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDx_DrawColorControl 
//               Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_DrawColorControl.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_DrawColorControl component.
#include "TDx_Draw.H"
// --------------------------------------------------------------------------
// external classes used by TDx_DrawColorControl methods.
#include "TDDColorControl.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_DrawColorControl*)
{
    new TDx_DrawColorControl(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_drawcolorcontrol
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_DrawColorControl)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_DrawColorControl::TDx_DrawColorControl()
// Description: The default constructor for the TDx_DrawColorControl object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawColorControl::TDx_DrawColorControl(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DD_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_DrawColorControl::~TDx_DrawColorControl()
// Description: The destructor for the TDx_DrawColorControl object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawColorControl::~TDx_DrawColorControl()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTDRAWCOLORCONTROL used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTDRAWCOLORCONTROL, call the 
//              TDx_DrawColorControl::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawColorControl::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawColorControl::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTDRAWCOLORCONTROL==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_DrawColorControl method or 
//              fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_DrawColorControl::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawColorControl::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTDRAWCOLORCONTROL interface used in the 
//              TDx_DrawColorControl component and must be called before any 
//              methods of the TDx_DrawColorControl component will function. 
// Params:      pDraw - 
//                A TDX_Draw object responsible for the created ColorControl. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawColorControl::Create( TDx_Draw* pDraw )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }

// code that creates the internal interface
fErrorValue = pDraw->Internal_LPDIRECTDRAW7->QueryInterface( IID_IDirectDrawColorControl, (LPVOID*) &fLPDIRECTDRAWCOLORCONTROL);

// check for error result
if (fErrorValue!=DD_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() failed with Error: "+TDx_Draw_Library_ErrorString(fErrorValue)+", "+TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTDRAWCOLORCONTROL interface used in the 
//              TDx_DrawColorControl component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawColorControl::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interfaces
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTDRAWCOLORCONTROL==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTDRAWCOLORCONTROL is NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTDRAWCOLORCONTROL->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception occurred in LPDIRECTDRAWCOLORCONTROL->Release(). Check you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTDRAWCOLORCONTROL = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetColorControls()
// Description: The TDx_DrawColorControl::GetColorControls method will 
//              retrieve the current color control settings. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_UNSUPPORTED 
// Params:      pColorControl - 
//                The ColorControl parameter will reference the current color 
//                control settings if this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawColorControl::GetColorControls( TDDColorControl* pColorControl )
{
// Original Function Definition
// HRESULT GetColorControls( 
//   LPDDCOLORCONTROL lpColorControl   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetColorControls()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pColorControl==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetColorControls()", "TDX_BADPARAMS", "'pColorControl' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWCOLORCONTROL->GetColorControls( pColorControl->Internal_DDCOLORCONTROL_Ptr );

// Translate Data returned from Function
pColorControl->Internal_DDCOLORCONTROL_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetColorControls()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetColorControls()
// Description: The TDx_DrawColorControl::SetColorControls method will set 
//              the color controls. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_UNSUPPORTED 
// Params:      pColorControl - 
//                The ColorControl parameter references the color control 
//                settings that are to be set. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawColorControl::SetColorControls( TDDColorControl* pColorControl )
{
// Original Function Definition
// HRESULT SetColorControls( 
//   LPDDCOLORCONTROL lpColorControl   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetColorControls()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pColorControl==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetColorControls()", "TDX_BADPARAMS", "'pColorControl' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWCOLORCONTROL->SetColorControls( pColorControl->Internal_DDCOLORCONTROL_Ptr );

// Translate Data returned from Function
pColorControl->Internal_DDCOLORCONTROL_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetColorControls()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTDRAWCOLORCONTROL __fastcall TDx_DrawColorControl::FGetInternal_LPDIRECTDRAWCOLORCONTROL()
{
return fLPDIRECTDRAWCOLORCONTROL;
}
// --------------------------------------------------------------------------
LPDIRECTDRAWCOLORCONTROL* __fastcall TDx_DrawColorControl::FGetInternal_LPDIRECTDRAWCOLORCONTROL_Ptr()
{
return &fLPDIRECTDRAWCOLORCONTROL;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawColorControl::FSetInternal_LPDIRECTDRAWCOLORCONTROL( LPDIRECTDRAWCOLORCONTROL pLPDIRECTDRAWCOLORCONTROL )
{
if (!fCreated)
    {
    fLPDIRECTDRAWCOLORCONTROL = pLPDIRECTDRAWCOLORCONTROL;
    fCreated = (fLPDIRECTDRAWCOLORCONTROL!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawColorControl::Internal_LPDIRECTDRAWCOLORCONTROL_Update()
{
fCreated = (fLPDIRECTDRAWCOLORCONTROL!=NULL);
}

// --------------------------------------------------------------------------
