// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_DrawVideoPortContainer.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the 
//               TDx_DrawVideoPortContainer Component 
//
// "TDx_Draw_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_DrawVideoPortContainer.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_DrawVideoPortContainer component.
#include "TDx_Draw.H"
// --------------------------------------------------------------------------
// external classes used by TDx_DrawVideoPortContainer methods.
#include "TDDVideoPortDesc.H"
#include "TDx_DrawVideoPort.H"
#include "TDDVideoPortCaps.H"
#include "TDDVideoPortConnect.H"
#include "TDDVideoPortStatus.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw_Library_Defns"
#pragma link "TDx_Draw_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_DrawVideoPortContainer*)
{
    new TDx_DrawVideoPortContainer(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_drawvideoportcontainer
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_DrawVideoPortContainer)};
        RegisterComponents("TDx_Draw", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Extra code for Callback Handling
// --------------------------------------------------------------------------
TDx_DrawVideoPortContainer* TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner = NULL;

// --------------------------------------------------------------------------
// Constructor: TDx_DrawVideoPortContainer::TDx_DrawVideoPortContainer()
// Description: The default constructor for the TDx_DrawVideoPortContainer object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawVideoPortContainer::TDx_DrawVideoPortContainer(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = DD_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_DrawVideoPortContainer::~TDx_DrawVideoPortContainer()
// Description: The destructor for the TDx_DrawVideoPortContainer object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawVideoPortContainer::~TDx_DrawVideoPortContainer()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDDVIDEOPORTCONTAINER used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDDVIDEOPORTCONTAINER, call the 
//              TDx_DrawVideoPortContainer::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawVideoPortContainer::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDDVIDEOPORTCONTAINER==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_DrawVideoPortContainer method 
//              or fget/fset. eg. DD_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_DrawVideoPortContainer::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawVideoPortContainer::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDDVIDEOPORTCONTAINER interface used in the 
//              TDx_DrawVideoPortContainer component and must be called 
//              before any methods of the TDx_DrawVideoPortContainer 
//              component will function. 
// Params:      pDraw - 
//                The TDx_Draw object that will manage the created 
//                VideoPortContainer. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::Create( TDx_Draw* pDraw )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }

// code that creates the internal interface
fErrorValue = pDraw->Internal_LPDIRECTDRAW7->QueryInterface( IID_IDDVideoPortContainer, (LPVOID*) &fLPDDVIDEOPORTCONTAINER);

// check for error result
if (fErrorValue!=DD_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() failed with Error: "+TDx_Draw_Library_ErrorString(fErrorValue)+", "+TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      CreateVideoPort()
// Description: The TDx_DrawVideoPortContainer::CreateVideoPort method will 
//              create a video port as defined by the settings of the Flags 
//              and VideoPortDesc parameters. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_CURRENTLYNOTAVAIL 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_NOCOOPERATIVELEVELSET 
//              DDERR_OUTOFCAPS 
//              DDERR_OUTOFMEMORY 
// Params:      pFlags - 
//                The Flags parameter defines flags indicating which portion of 
//                the video stream the video-port will control. 
//                The described effect applies when the flag is set. 
//                Set this parameteer to NULL if no control options are needed. 
//                Flags:
//                  DDVPCREATE_VBIONLY -
//                    The new video port will only control the VBI portion of 
//                    the video stream. 
//                  DDVPCREATE_VIDEOONLY -
//                    The new video port will only control the non-VBI 
//                    portion of the video stream. 
//              pVideoPortDesc - 
//                The VideoPortDesc parameter references a TDDVideoPortDesc 
//                component defining the properties of the video port being 
//                created. 
//              pVideoPort - 
//                The VideoPort parameter will reference the new video port if 
//                this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::CreateVideoPort( dword pFlags, TDDVideoPortDesc* pVideoPortDesc, TDx_DrawVideoPort* pVideoPort )
{
// Original Function Definition
// HRESULT CreateVideoPort( 
//   DWORD dwFlags,                               
//   LPDDVIDEOPORTDESC lpDDVideoPortDesc,         
//   LPDIRECTDRAWVIDEOPORT FAR *lplpDDVideoPort,   
//   IUnknown FAR *pUnkOuter                       
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::CreateVideoPort()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pVideoPortDesc==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::CreateVideoPort()", "TDX_BADPARAMS", "'pVideoPortDesc' cannot be 'NULL'");
    return false;
    }
if (pVideoPort==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::CreateVideoPort()", "TDX_BADPARAMS", "'pVideoPort' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDDVIDEOPORTCONTAINER->CreateVideoPort( (DWORD) pFlags, pVideoPortDesc->Internal_DDVIDEOPORTDESC_Ptr, pVideoPort->Internal_LPDIRECTDRAWVIDEOPORT_Ptr, NULL );

// Translate Data returned from Function
pVideoPortDesc->Internal_DDVIDEOPORTDESC_Update();
pVideoPort->Internal_LPDIRECTDRAWVIDEOPORT_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::CreateVideoPort()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDDVIDEOPORTCONTAINER interface used in the 
//              TDx_DrawVideoPortContainer component and should be called 
//              when the internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interfaces
if (FOnDestroy) FOnDestroy(this);

if (fLPDDVIDEOPORTCONTAINER==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDDVIDEOPORTCONTAINER is NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDDVIDEOPORTCONTAINER->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception occurred in LPDDVIDEOPORTCONTAINER->Release(). Check you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDDVIDEOPORTCONTAINER = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      EnumVideoPorts()
// Description: The TDx_DrawVideoPortContainer::EnumVideoPorts method will 
//              enumerate video ports that are compatible with the specified 
//              capabilities. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
// Params:      pVideoPortCaps - 
//                The VideoPortCaps parameter references a TDDVideoPortCaps 
//                component defining the capabilities that are to be checked 
//                against the available video ports. 
//                When this parameter is set to NULL, all video ports will be 
//                enumerated. 
//              pContext - 
//                The Context parameter references a caller defined object that 
//                is to be passed to the 
//                TDx_DrawVideoPortContainer::EnumVideoCallback() event for 
//                each video port enumerated. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::EnumVideoPorts( TDDVideoPortCaps* pVideoPortCaps, void* pContext )
{
// Original Function Definition
// HRESULT EnumVideoPorts( 
//   DWORD dwFlags,                         
//   LPDDVIDEOPORTCAPS lpDDVideoPortCaps,   
//   LPVOID lpContext,                     
//   LPDDENUMVIDEOCALLBACK lpEnumVideoCallback   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::EnumVideoPorts()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Call Original Function
TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner = this;
fErrorValue = fLPDDVIDEOPORTCONTAINER->EnumVideoPorts( 0, (pVideoPortCaps==NULL) ? NULL : pVideoPortCaps->Internal_DDVIDEOPORTCAPS_Ptr, (LPVOID) pContext, Internal_EnumVideoPortsCallback );
TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner = NULL;

// Translate Data returned from Function
if (pVideoPortCaps!=NULL) pVideoPortCaps->Internal_DDVIDEOPORTCAPS_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::EnumVideoPorts()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetVideoPortConnectInfo()
// Description: The TDx_DrawVideoPortContainer::GetVideoPortConnectInfo 
//              method will retrieve connection information from the 
//              specified video port. Before calling this method, make sure 
//              to setup the TDDVideoPortConnect multiwrapper component with 
//              appropriate data. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DSERR_INVALIDPARAM 
//              DSERR_OUTOFMEMORY 
// Params:      pPortId - 
//                The PortId parameter defines the ID of the video port for 
//                which connection information is to be retrieved. 
//              pNumEntries - 
//                The NumEntries parameter references the size of the array 
//                referenced by the ConnectInfo parameter of this method. 
//                When this value is less than the total connections, the array 
//                is filled, this parameter is set to the total number of 
//                connections and DDERR_MOREDATA returned in both fErrorValue 
//                and the OnError() event. 
//              pConnectInfo - 
//                The ConnectInfo parameter references a TDDVideoPortConnect 
//                multiwrapper component used for holding the retrieved 
//                connection information if this method returns successfully. 
//                When this parameter is NULL, the NumEntries parameter of this 
//                component will be set to the total number of connections 
//                supported and true returned. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::GetVideoPortConnectInfo( dword pPortId, dword* pNumEntries, TDDVideoPortConnect* pConnectInfo )
{
// Original Function Definition
// HRESULT GetVideoPortConnectInfo(
//   DWORD dwPortId,
//   LPDWORD lpNumEntries,
//   LPDDVIDEOPORTCONNECT lpConnectInfo
// );

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetVideoPortConnectInfo()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pNumEntries==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetVideoPortConnectInfo()", "TDX_BADPARAMS", "'pNumEntries' cannot be 'NULL'");
    return false;
    }

// Check Parameters for Accuracy
if (pConnectInfo!=NULL)
    if (*pNumEntries > pConnectInfo->ArraySize)
        {
        fErrorValue = TDX_BADPARAMS;
        if (FOnError) FOnError( this, Name+"::GetVideoPortConnectInfo()", "TDX_BADPARAMS", "'*pNumEntries' cannot be larger than "+pConnectInfo->Name+"::ArraySize ["+IntToStr(pConnectInfo->ArraySize)+"].");
        return false;
        }

// Translate parameters
LPDDVIDEOPORTCONNECT connect = (pConnectInfo!=NULL) ? NULL : pConnectInfo->Internal_DDVIDEOPORTCONNECT_Ptr;

// Call Original Function
fErrorValue = fLPDDVIDEOPORTCONTAINER->GetVideoPortConnectInfo( (DWORD) pPortId, (LPDWORD) pNumEntries, connect );

// Translate Data returned from Function
if (pConnectInfo!=NULL) pConnectInfo->Internal_DDVIDEOPORTCONNECT_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetVideoPortConnectInfo()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}

// --------------------------------------------------------------------------
// Method:      Internal_EnumVideoPortsCallback()
// Description: The Internal_EnumVideoPortsCallback method is used internally 
//              by the TDx_Draw_Library to redirect a standard callback 
//              function to a BCB style event. 
// Params:      pDDVideoPortCaps - 
//                The DDVideoPortCaps parameter describes the currently 
//                enumerated VideoPort. 
//              pContext - 
//                Application defined data passed to the enumeration method 
//                call. 
// --------------------------------------------------------------------------
HRESULT __stdcall TDx_DrawVideoPortContainer::Internal_EnumVideoPortsCallback( LPDDVIDEOPORTCAPS pDDVideoPortCaps, LPVOID pContext )
{
// Original Function Definition
// HRESULT WINAPI EnumVideoCallback(
//   LPDDVIDEOPORTCAPS lpDDVideoPortCaps,  
//   LPVOID lpContext                      
// );

// Allocate temporary storage for converted data
TDDVideoPortCaps* caps = new TDDVideoPortCaps(TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner);
if (caps==NULL)
    {
    TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->fErrorValue = TDX_ERROR;
    if (TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->FOnError)
TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->FOnError( TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner, TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->Name+"::Internal_EnumVideoCallback()", "TDX_ERROR", "Could not create a temporary TDDVideoPortCaps component." );
    return DDENUMRET_CANCEL;
    }

// Translate Parameters before calling Original Function
CopyMemory( caps->Internal_DDVIDEOPORTCAPS_Ptr, pDDVideoPortCaps, sizeof(DDVIDEOPORTCAPS));
void* context = pContext;

// transfer to the Callback Event (if it exists)
bool finished = false;
if (TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->OnEnumVideoPorts) TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner->OnEnumVideoPorts( TDx_DrawVideoPortContainer_OnEnumVideoPortsOwner, caps, context, finished );

// cleanup as required
delete caps;

// Finished, return 1 if not aborted
if (finished) return DDENUMRET_CANCEL;
return DDENUMRET_OK;
}

// --------------------------------------------------------------------------
// Method:      QueryVideoPortStatus()
// Description: The TDx_DrawVideoPortContainer::QueryVideoPortStatus method 
//              will retrieve the status of the specified video port. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_CURRENTLYNOTAVAIL 
//              DDERR_EXCEPTION 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_UNSUPPORTED 
// Params:      pPortId - 
//                The PortId parameter defines the ID of the video port for 
//                which status information is to be retrieved. 
//              pVPStatus - 
//                The VPStatus parameter references a TDDVideoPortStatus 
//                component for holding the retrieved status information if 
//                this method returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawVideoPortContainer::QueryVideoPortStatus( dword pPortId, TDDVideoPortStatus* pVPStatus )
{
// Original Function Definition
// HRESULT QueryVideoPortStatus( 
//   DWORD dwPortId,                 
//   LPDDVIDEOPORTSTATUS lpVPStatus   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::QueryVideoPortStatus()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pVPStatus==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::QueryVideoPortStatus()", "TDX_BADPARAMS", "'pVPStatus' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDDVIDEOPORTCONTAINER->QueryVideoPortStatus( (DWORD) pPortId, pVPStatus->Internal_DDVIDEOPORTSTATUS_Ptr );

// Translate Data returned from Function
pVPStatus->Internal_DDVIDEOPORTSTATUS_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::QueryVideoPortStatus()", TDx_Draw_Library_ErrorString(fErrorValue), TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDDVIDEOPORTCONTAINER __fastcall TDx_DrawVideoPortContainer::FGetInternal_LPDDVIDEOPORTCONTAINER()
{
return fLPDDVIDEOPORTCONTAINER;
}
// --------------------------------------------------------------------------
LPDDVIDEOPORTCONTAINER* __fastcall TDx_DrawVideoPortContainer::FGetInternal_LPDDVIDEOPORTCONTAINER_Ptr()
{
return &fLPDDVIDEOPORTCONTAINER;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawVideoPortContainer::FSetInternal_LPDDVIDEOPORTCONTAINER( LPDDVIDEOPORTCONTAINER pLPDDVIDEOPORTCONTAINER )
{
if (!fCreated)
    {
    fLPDDVIDEOPORTCONTAINER = pLPDDVIDEOPORTCONTAINER;
    fCreated = (fLPDDVIDEOPORTCONTAINER!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawVideoPortContainer::Internal_LPDDVIDEOPORTCONTAINER_Update()
{
fCreated = (fLPDDVIDEOPORTCONTAINER!=NULL);
}

// --------------------------------------------------------------------------
